SystemOrganization addCategory: #'CodeModel-Tests'!
SystemOrganization addCategory: #'CodeModel-Model'!
SystemOrganization addCategory: #'CodeModel-Iterators'!

TestCase subclass: #CMPackageInfoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageInfoTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/15/2004 01:11'!
testImport
	| package |
	package _ CMPackage fromPackageInfo: (PackageInfo hidden: 'Bogus').
	package classes 
				with: BogusInfo classes 
				do: [:node :class | self assert: (node refersTo: class)]
	! !

Object subclass: #CMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

Object subclass: #CMNode
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/15/2004 00:55'!
children
	^ children ifNil: [children _ OrderedCollection new]! !

CMNode subclass: #CMClass
	instanceVariableNames: 'name superName type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMClass methodsFor: 'accessing' stamp: 'cwp 5/15/2004 00:49'!
name
	^ name! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/15/2004 00:59'!
isClass
	^ true! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/15/2004 01:30'!
refersTo: anObject
	anObject isBehavior ifFalse: [^ false].
	name = anObject name ifFalse: [^ false].
	superName = anObject superclass name ifFalse: [^ false].
	type = anObject typeOfClass ifFalse: [^ false]. 
	^ true! !

!CMClass methodsFor: 'initializing' stamp: 'cwp 5/15/2004 01:16'!
initFromClass: aClass
	name _ aClass name.
	superName _ aClass superclass name.
	type _ aClass typeOfClass! !

!CMClass class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 01:16'!
fromClass: aClass
	^ self new initFromClass: aClass! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/14/2004 23:55'!
isClass
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/15/2004 00:38'!
addChild: aNode
	self children add: aNode! !

CMNode subclass: #CMBundle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBundle class methodsFor: 'as yet unclassified' stamp: 'cwp 5/14/2004 00:44'!
fromPackageInfo: packageName
 	^  CMBundle new addChild: (CMPackage new name: packageName)! !

CMNode subclass: #CMPackage
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/14/2004 01:02'!
name: aString 
	name _ aString! !

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/14/2004 23:58'!
classes
	^ self children select: [:ea | ea isClass]! !

!CMPackage class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 00:45'!
fromPackageInfo: aPackageInfo
	| package |
	package _ self new name: aPackageInfo packageName.
	aPackageInfo classes do: [:ea | package addChild: (CMClass fromClass: ea)].
	^ package
	! !

!CMNode methodsFor: 'printing' stamp: 'cwp 5/15/2004 01:23'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $<.
	aStream nextPutAll: self name.
	aStream nextPut: $>! !
